"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
const bluestream_1 = require("bluestream");
// Bluestream based scan streams
class ScanStream extends bluestream_1.ReadStream {
    constructor(_a) {
        var { redis, command, key, match, count } = _a, opts = __rest(_a, ["redis", "command", "key", "match", "count"]);
        super(opts);
        this._redis = redis;
        this._command = command;
        this._nextCursor = '0';
        this._key = key;
        this._match = match;
        this._count = count ? String(count) : undefined;
    }
    async _read() {
        const { _key, _match, _count } = this;
        const args = [this._nextCursor];
        if (_key) {
            args.unshift(_key);
        }
        if (_match) {
            args.push('MATCH', _match);
        }
        if (_count) {
            args.push('COUNT', _count);
        }
        const [nextCursor, redisIds] = await this._redis[this._command](...args);
        this._nextCursor = nextCursor instanceof Buffer ? nextCursor.toString() : nextCursor;
        this.push(redisIds);
        if (this._nextCursor === '0') {
            this.push(null);
        }
    }
}
exports.ScanStream = ScanStream;
